

.include 	"tn13Adef.inc"			;  AtTiny13


.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20				;   /  SREG
.def	Temp5=R21 				;     PB0/PB1
.def	Temp6=R22				;     
.def	Temp7=R23				;     	
.def	Temp8=R24				;  
.def	Temp9=R25


.dseg						; 

OZU: .byte 2					;  2   


;******************************************************************************


.cseg			



.org 0						; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset

rjmp RESET				



.org PCI0addr					; External Interrupt Request 0

rjmp PCINT_01




.org INT_VECTORS_SIZE				;   


;******************************************************************************
; 
;******************************************************************************

reset:						;  




	cli					;    


	ldi Temp,low(RamEnd)			;  	
	out SPL,Temp				;

	
	ldi Temp,0b00111111			;   "" (0-, 1-)
	out DDRB,Temp				; 
					

	ldi Temp,0b00000000			;   !
	out PortB,Temp				;

;_________________________________________________________________________________



	ldi Temp,(1<<PCIE)			;     PCIE
	out GIMSK, Temp


	ldi Temp,(1<<PCINT0)			;     PB0
	out PCMSK, Temp



	ldi Temp,(1<<cs01)|(1<<cs00)		;    = CK 1:64  					??? 
	out TCCR0B, Temp	


	ldi Temp,0				;   ( 8- !!! )
	out TCNT0,Temp	


	ldi Temp5,0				;     PB0


	ldi Temp6, 0				;  /    


	sei					;   
	

;*******************************************************************************
;  
;*******************************************************************************



Main_cicle:


	
	rjmp Main_cicle			; 


;*******************************************************************************
;  
;*******************************************************************************

PCINT_01:



	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4



	in Temp7,TCNT0			;     "X"   "TCNT0"




	ldi Temp,0			;   
	out TCNT0,Temp


;_________________________________________________________________________________
;       
;_________________________________________________________________________________


	cpi Temp5,0			;       PB0 ?
	breq PCINT_0
	RJMP PCINT_1

;_________________________________________________________________________________
;       PB0
;_________________________________________________________________________________

PCINT_0:

	IN Temp, PINB			;    ""

	andi Temp8, 0b00000001		;  "1"   ,  "0"   ! () 

	cpi Temp, 1			;      ?
	breq out_2			;  ,     

	cpi Temp6, 1			;    ?
	brne out_1			;  ,  



;_________________________
;    



	rcall compare_7_8		; ...

	breq bolshe_0			;     Temp7=Temp8
	brcs menshe_0			;     Temp7<Temp8
	rjmp bolshe_0			;     Temp7>Temp8


;_________________________



return_0:


 	ldi Temp6, 0			;    
	
	ldi Temp5, 1			;   PB1

	ldi Temp,(1<<PCINT1)		;     PB1
	out PCMSK, Temp

	rjmp out_1			;  

;_________________________________________________________________________________
;       PB1
;_________________________________________________________________________________

PCINT_1:

	IN Temp, PINB			;    ""

	andi Temp8, 0b00000010		;  "1"   ,  "0"   ! () 

	cpi Temp, 1			;      ?
	breq out_1			;  ,  

	cpi Temp6, 1			;    ?
	brne out_1			;  ,  



;_________________________
;    



	rcall compare_7_8		; ...

	breq bolshe_1			;     Temp7=Temp8
	brcs menshe_1			;     Temp7<Temp8
	rjmp bolshe_1			;     Temp7>Temp8


;_________________________

return_1:


	ldi Temp6, 0			;    
	
	ldi Temp5, 0			;   PB0

	ldi Temp,(1<<PCINT0)		;     PB0
	out PCMSK, Temp

	rjmp out_1			;  


;__________________________________________________________________________________
;    
;__________________________________________________________________________________

out_2:

	ldi Temp6, 1			;    	

	rjmp out_1			;  

;__________________________________________________________________________________
;    
;__________________________________________________________________________________

out_1:

	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4

	RETI				;   



;*****************************************************************************************
;   
;*****************************************************************************************

compare_7_8:



	ldi Temp8, 28			;  28   ( 1484 )

	cp Temp7,Temp8			;    
					;  Z=1  Temp7=Temp8
					;   -   Temp7<Temp8
					;   -   Temp7>Temp8

	ret                            



;*****************************************************************************************
;    / 
;*****************************************************************************************

bolshe_0:					;    


	Sbi PortB, 3				;      "" -   // PB3

	rjmp return_0				; 



menshe_0:					;    		


	Cbi PortB, 3				;      "" -   // PB3

	rjmp return_0				; 


;*****************************************************************************************



bolshe_1:					;    


	Sbi PortB, 4				;  _4   "" -   // PB4

	rjmp return_1				; 



menshe_1:					;    		


	Cbi PortB, 4				;  _4   "" -   // PB4

	rjmp return_1				; 


;*****************************************************************************************
